/*
 *  Copyright 2013-2050 Emmanuel BRUN (contact@amapj.fr)
 * 
 *  This file is part of AmapJ.
 *  
 *  AmapJ is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.

 *  AmapJ is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with AmapJ.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 */
 package fr.amapj.view.views.utilisateur;

import java.util.Date;

import com.vaadin.ui.Button;

import fr.amapj.common.DateUtils;
import fr.amapj.common.FormatUtils;
import fr.amapj.common.SimpleMail;
import fr.amapj.service.services.authentification.ProcessSetPasswordService;
import fr.amapj.service.services.utilisateur.UtilisateurDTO;
import fr.amapj.service.services.utilisateur.UtilisateurService;
import fr.amapj.service.services.utilisateur.util.UtilisateurUtil;
import fr.amapj.view.engine.popup.formpopup.WizardFormPopup;
import fr.amapj.view.engine.popup.mailpopup.SaisieMailContentPopup;

/**
 * Popup pour résoudre les problèmes de connexion d'un utilisateur 
 * On peut soit un mail de bienvenue complet avec un lien pour saisir son mot de passe, 
 * soit uniquement un lien pour changer le mot de passe   
 */
public class PopupHandlePasswordConnexion extends WizardFormPopup
{		

	private UtilisateurDTO dto;
	
	private SimpleMail mailContent;
	
	public PopupHandlePasswordConnexion(Long idUtilisateur)
	{
		popupTitle = "Résoudre les problèmes de mot de passe / connexion";
		dto = new UtilisateurService().loadUtilisateurDto(idUtilisateur);
	}
	
	
	@Override
	protected void configure()
	{
		add(()->addFieldInfoGenerales());
		add(()->addFieldResultat());
	}

	
	protected void addFieldInfoGenerales()
	{
		if (UtilisateurUtil.canSendMailTo(dto.email)==false)
		{
			addHtml("L'utilisateur "+s(dto.nom)+" "+s(dto.prenom)+" n'a pas d'email. Il n'est donc pas possible de lui envoyer des informations pour se connecter.");
			setBackOnlyMode();
			return;
		}
		
		String s = " ";
		if (dto.lastConnexion==null)
		{
			mailContent = new ProcessSetPasswordService().getInitialMailBienvenue();
			
			addHtml("L'utilisateur "+s(dto.nom)+" "+s(dto.prenom)+" ne s'est jamais connecté.");
			if (dto.processSetPasswordDate==null)
			{
				addHtml("Aucun email de bienvenue n'a été envoyé à cet utilisateur auparavant.");
			}
			else
			{
				addInfoPreviousMail();
				s= "de nouveau ";
			}
			
			addHtml("En appuyant sur Suivant, vous allez lui envoyer"+s+"un mail qui lui précisera comment créer son mot de passe et se connecter<br/><br/>"+
					"Vous pouvez voir / modifier le mail qui va être envoyé en cliquant sur le bouton ci dessous.");
					
			
			Button btn = new Button("Voir / Modifier le contenu du mail qui sera envoyé");
			btn.addClickListener(e->new SaisieMailContentPopup("Voir / Modifier le contenu du mail envoyé",mailContent).open());
			form.addComponent(btn);
			
		}
		else
		{
			
			addHtml("L'utilisateur "+s(dto.nom)+" "+s(dto.prenom)+" s'est déjà connecté.");
			addHtml("Date de la dernière connexion : "+dto.getConnexionInfo());
			
			
			if (dto.processSetPasswordDate!=null)
			{
				addInfoPreviousMail();
				s= "de nouveau ";
			}
			
			
			addHtml("En appuyant sur Suivant, vous allez lui envoyer "+s+"un mail qui lui précisera comment se connecter et comment changer son mot de passe si besoin.");
				
		}
	}
	
	
	private void addInfoPreviousMail() 
	{
		addHtml("Avec cet écran, un TRESORIER a déjà envoyé un mail à cet utilisateur le "+FormatUtils.getTimeStd().format(dto.processSetPasswordDate));
		Date d = DateUtils.addMinute(dto.processSetPasswordDate,dto.processSetPasswordValidityDelay);
		if (d.after(DateUtils.getDate()))
		{
			addHtml("Le mail envoyé est encore valable.<br/>");
		}
		else
		{
			addHtml("Le mail envoyé est périmé maintenant.<br/>"); 
		}
	}


	private void addFieldResultat()
	{
		// Titre
		setStepTitle("Résultats");
		
		
		if (dto.lastConnexion==null)
		{
			new ProcessSetPasswordService().sendMailBienvenue(dto.id, mailContent.title,mailContent.content);
		}
		else
		{
			new ProcessSetPasswordService().sendMailByTresorierForResetPassword(dto.id);
		}
		
		
		// 
		addHtml("Le mail a été envoyé avec succés.");
		setAllButtonsAsOK();
		
	}

	protected void performSauvegarder()
	{
		// Nothing to do 
	}

	
	

}
